"use strict";
import _Router, {_AsyncRouterMap, _ConstantRouterMap} from '../../router'

import store from '../../basement/service/store'

_Router.beforeEach((to, from, next) => {
  _routerInterceptor(to, from, next);
});

_Router.afterEach((to, from) => {
  // console.log('permission afterEach > ', to, from);
});

const _routerInterceptor = function (to, from, next) {
  console.log('Permission router > interceptor > ', 'from : ', from.path, 'to : ', to.path);

  // 0 User session
  console.log('Permission router > interceptor > user session', store.getters.userSession);

  // 1 路由初始化
  if (!_Router.initialized) {
    _initializeRouter(to, from, next);
    return;
  }

  // 2 Settings breadcrumb
  _breadcrumbHandler(to, from);
  console.log('Permission router > interceptor > next');

  // 3 proxy pass
  next();
};

const _initializeRouter = function (to, from, next) {
  console.log('Permission router > initialize > _ConstantRouterMap >', _ConstantRouterMap);
  _Router.addRoutes(_AsyncRouterMap);
  console.log('Permission router > initialize > _AsyncRouterMap > ', _AsyncRouterMap);
  _Router.initialized = true;
  if (to.path) {
    next({path: to.path});
  } else {
    next({path: '/'});
  }
};

const _breadcrumbHandler = function (to, from) {
  console.log('Permission router > breadcrumb handler');
  if (to.matched && to.matched.length > 0) {
    store.dispatch('setBreadcrumb', {items: to.matched}).then(
        (_response) => {
          // ignore
        }, (_reason) => {
          // ignore
        }
    );
  } else {
    store.dispatch('setBreadcrumb', {items: []}).then(
        (_response) => {
          // ignore
        }, (_reason) => {
          // ignore
        }
    );
  }
};