'use strict';
import Vue from 'vue';

if (!window.triggerSelectorChangeEvent) {
  window.triggerSelectorChangeEvent = function (_el, _value) {
    // console.log('Selector > triggerSelectorChangeEvent', _el, _value);
    let changeSelectorEvent = new Event('changeSelector');
    _el.value = _value;
    _el.dispatchEvent(changeSelectorEvent, _value);
  };
}

const selector = Vue.directive('selector', {
  bind: function (_el, _binding) {
  },
  inserted: function (_el, _binding) {
    // console.log('Selector -> inserted', _el, _binding);
    bindSelectorInput(_el, _binding);
  },
  unbind: function (_el, _binding) {
    // console.log('Selector -> unbind', _el, _binding);
  }
});

const bindSelectorInput = function (_el, _binding) {

  _el.onkeydown = function (_evt) {
    onSelectorKeyDownHandler(_el, _binding);
    return false;
  };

  _el.addEventListener('focus', function (_evt) {
    onSelectorFocusHandler(_el, _binding);
  });

  // console.log('Selector > add event changeSelector', _el);
  _el.addEventListener('changeSelector', function (_evt) {
    // console.log('Selector > changeSelector', _evt);
    triggerValidatorElementEvent(_el);
  });

};

const onSelectorKeyDownHandler = function (_el, _binding) {
  // console.log('selector > onSelectorKeyDownHandler');
  return false;
};

const onSelectorFocusHandler = function (_el, _binding) {
  let _key = _el.getAttribute('data-key');
  //console.log('selector > onSelectorFocusHandler', _el, _key);
  if (_key) {
    _binding.value(_key);
  } else {
    _binding.value();
  }
  return false;
};

export default selector;
