"use strict";
const app = {
  state: {
    breadcrumb: {
      items: []
    },
    userSession: undefined,
    userNotice: undefined
  },
  mutations: {
    SET_BREADCRUMB: (state, breadcrumb) => {
      state.breadcrumb = breadcrumb;
    },
    SET_USER_SESSION: (state, userSession) => {
      state.userSession = userSession;
    },
    SET_USER_NOTICE: (state, userNotice) => {
      state.userNotice = userNotice;
    }
  },
  actions: {
    setBreadcrumb({commit}, breadcrumb) {
      return new Promise(function (resolve, reject) {
        commit('SET_BREADCRUMB', breadcrumb);
        resolve(breadcrumb);
      });
    },

    setUserSession({commit}, userSession) {
      return new Promise(function (resolve, reject) {
        commit('SET_USER_SESSION', userSession);
        resolve(userSession);
      });
    },

    setUserNotice({commit}, userNotice) {
      return new Promise(function (resolve, reject) {
        commit('SET_USER_NOTICE', userNotice);
        resolve(userNotice);
      });
    }
  }
};

export default app
